// to represent an abstract binary search tree
public abstract class ABSTBook{
  
  // the comparator that determines the tree ordering
  protected ICompareBooks comp;
	
  public ABSTBook(ICompareBooks comp){
    this.comp = comp;
  }
	
  // insert the given data into this binary search tree
  abstract public ABSTBook insert(Book data);
  
  // is this tree the same in shape and data as the given tree?
  abstract public boolean sameTree(ABSTBook that);
  
  // is this tree the same as the given leaf?
  abstract public boolean sameLeaf(LeafBook that);
  
  // is this tree the same in shape and data 
  // as the tree with the given root node?
  abstract public boolean sameNode(NodeBook that);
}