// to represent an empty list of books
class ConsLoB implements ILoB{
  Book first;
  ILoB rest;
  
  ConsLoB(Book first, ILoB rest){
    this.first = first;
    this.rest = rest;
  }
  
/* TEMPLATE:
   FIELDS:
   ... this.first ...    -- Book
   ... this.rest ...     -- ILoB
   
   METHODS:
   ... this.sort(ICompareBooks) ...         -- ILoB(sorted)
   ... this.insert(Book, ICompareBooks) ... -- ILoB(sorted)
   
   METHODS FOR FIELDS:
   ... this.rest.sort(ICompareBooks) ...         -- ILoB(sorted)
   ... this.rest.insert(Book, ICompareBooks) ... -- ILoB(sorted)  
*/
  
  // produce a list from this list that is sorted in the given order
  public ILoB sort(ICompareBooks order){
    return this.rest.sort(order).insert(this.first, order);
  }
  
  // insert the given book into this list sorted in the given order
  // producing a sorted list
  public ILoB insert(Book b, ICompareBooks order){
    if (order.compare(b, this.first))
      return new ConsLoB(b, this);
    else
      return new ConsLoB(this.first, this.rest.insert(b, order));
  }
  
  // is this list of books sorted in the given order?
  public boolean isSorted(ICompareBooks order){
    return this.rest.isSortedAfter(this.first, order);
  }
  
  //is this list of books sorted in the given order, 
  // with the first item coming after the given book?
  public boolean isSortedAfter(Book b, ICompareBooks order){
    return order.compare(b, this.first) &&
           this.rest.isSortedAfter(this.first, order);
  }
  
  /*
  // produce a list from this list that is sorted in the given order
  public ILoB bstsort(ICompareBooks order){
    return this.buildTree(new LeafBook(order)).buildList();
  }
  */
  
  // produce a binary search tree from this list, using the give ordering
  public ABSTBook buildTree(ABSTBook acc){
    return this.rest.buildTree(acc.insert(this.first));
  }
}