import tester.*;

// examples and tests for lists of books
class ExamplesBooks{
  ExamplesBooks(){}
  
  Book eh1 = new Book("Old Man and the Sea", "EH", 1950);
  Book eh2 = new Book("Snows on Killimanjaro", "EH", 1954);
  Book eh3 = new Book("SAR", "EH", 1952);
  Book eh4 = new Book("AQOTWF", "EH", 1952);
  Book htdp = new Book("HtDP", "FFFK", 2001);
  Book sn = new Book("Shipping News", "EAP", 2000);
  Book dvc = new Book("DVC", "DB", 2000);
  Book pc = new Book("Beach", "PC", 2000);
  
  ILoB mtlob = new MtLoB();
  ILoB blistEH = new ConsLoB(this.eh1, new ConsLoB(this.eh2, this.mtlob));
  ILoB blist2000 = new ConsLoB(this.sn, this.mtlob);
  ILoB blistmix = new ConsLoB(this.eh1, new ConsLoB(this.sn, this.mtlob));

  ILoB blistAll = 
    new ConsLoB(this.eh1,
        new ConsLoB(this.sn,
            new ConsLoB(this.htdp,
                new ConsLoB(this.eh2, this.mtlob))));
  
  ILoB blistByTitle = 
    new ConsLoB(this.htdp,
        new ConsLoB(this.eh1,
            new ConsLoB(this.sn,
                new ConsLoB(this.eh2, this.mtlob))));
  
  ILoB blistByTitleLength = 
    new ConsLoB(this.htdp,
        new ConsLoB(this.sn,
            new ConsLoB(this.eh1,
                new ConsLoB(this.eh2, this.mtlob))));

  ILoB blistByTitleLengthEH4 = 
    new ConsLoB(this.htdp,
        new ConsLoB(this.eh4,
            new ConsLoB(this.sn,
                new ConsLoB(this.eh1,
                    new ConsLoB(this.eh2, this.mtlob)))));
  
  ILoB blistByAuthor = 
    new ConsLoB(this.sn,
        new ConsLoB(this.eh1,
            new ConsLoB(this.eh2,
                new ConsLoB(this.htdp, this.mtlob))));
  
  ILoB blistByYear = 
    new ConsLoB(this.eh1,
        new ConsLoB(this.eh2,
            new ConsLoB(this.sn,
                new ConsLoB(this.htdp, this.mtlob))));
  
  ICompareBooks booksByTitleLength = new BookOrderByTitleLength();
  ICompareBooks booksByAuthor = new BookOrderByAuthor();
  ICompareBooks booksByYear = new BookOrderByYear();
  
  // test sort(ICompareBooks order);
  boolean testSortBooks(Tester t){
    return
    t.checkExpect(this.mtlob.sort(this.booksByTitleLength), this.mtlob) &&
    t.checkExpect(this.blistAll.sort(this.booksByTitleLength), 
        this.blistByTitleLength) &&
    t.checkExpect(this.blistAll.sort(this.booksByAuthor), 
        this.blistByAuthor);
  }
  
  // test insert(Book b, ICompareBooks order);
  boolean testInsertBooks(Tester t){
    return
    t.checkExpect(this.mtlob.insert(this.eh1, this.booksByAuthor), 
        new ConsLoB(this.eh1, this.mtlob)) &&
    t.checkExpect(this.blistByTitleLength.insert(
        this.eh3, this.booksByTitleLength), 
        new ConsLoB(this.eh3, this.blistByTitleLength)) &&
    t.checkExpect(this.blistByTitleLength.insert(
        this.eh4, this.booksByTitleLength), 
        this.blistByTitleLengthEH4) &&
    t.checkExpect(this.blistAll.insert(this.dvc, this.booksByAuthor), 
        new ConsLoB(this.dvc, this.blistAll));
  } 
  
  // test the method isSorted for the lists of books
  boolean testIsSorted(Tester t){
    return
    t.checkExpect(this.mtlob.isSorted(this.booksByAuthor), true) &&
    t.checkExpect(this.blistByTitleLength.isSorted(this.booksByAuthor), 
                  false) &&
    t.checkExpect(this.blistByTitleLength.isSorted(this.booksByTitleLength), 
                  true) &&
    t.checkExpect(this.mtlob.isSortedAfter(this.eh3, booksByAuthor), 
                  true) &&
    t.checkExpect(this.blistByTitleLength.isSortedAfter(
                       this.dvc, booksByTitleLength), 
                  true);
  }
  
  ABSTBook leafByAuthor = new LeafBook(this.booksByAuthor);
  
  ABSTBook tree3 = 
    new NodeBook(this.eh1, 
                 new NodeBook(this.sn, 
                     this.leafByAuthor, this.leafByAuthor),
                 new NodeBook(this.htdp, 
                     this.leafByAuthor, this.leafByAuthor));
  
  ABSTBook tree3a = 
    new NodeBook(this.eh1, 
                 new NodeBook(this.sn, 
                     this.leafByAuthor, this.leafByAuthor),
                 new NodeBook(this.htdp, 
                     this.leafByAuthor, this.leafByAuthor));
  
  ABSTBook tree3b = 
    new NodeBook(this.sn,
                 this.leafByAuthor,
                 new NodeBook(this.eh1,
                              this.leafByAuthor,
                              new NodeBook(this.htdp, 
                                           this.leafByAuthor, 
                                           this.leafByAuthor)));
  
  ABSTBook tree4 = 
    new NodeBook(this.eh1, 
        new NodeBook(this.sn, 
            new NodeBook(this.dvc, this.leafByAuthor, this.leafByAuthor), 
            this.leafByAuthor),
        new NodeBook(this.htdp, this.leafByAuthor, this.leafByAuthor));

  ABSTBook tree4a = 
    new NodeBook(this.eh1, 
        new NodeBook(this.dvc,
            this.leafByAuthor,
            new NodeBook(this.sn, this.leafByAuthor, this.leafByAuthor)),
        new NodeBook(this.htdp, this.leafByAuthor, this.leafByAuthor));
  
  //test the method isLeaf for the binary search trees
  void testIsLeaf(Tester t){
    //t.checkExpect(this.leafByAuthor.isLeaf(), true);
    //t.checkExpect(this.tree4.isLeaf(), false);
  }
  
  //test the method getFirst for the binary search trees
  void testGetFirst(Tester t){
    //t.checkExpect(this.tree4.getFirst(), this.dvc);
    //t.checkExpect(this.tree4a.getFirst(), this.dvc);
    t.checkException(new RuntimeException("No first in an empty tree"),
                     this.leafByAuthor, "getFirst");
  }
  
  //test the method getLast for the binary search trees
  void testGetLast(Tester t){
    //t.checkExpect(this.tree3b.getLast(), this.htdp);
    //t.checkExpect(this.tree4a.getLast(), this.htdp);
    t.checkException(new RuntimeException("No last in an empty tree"),
                     this.leafByAuthor, "getLast");
  }
  
  //test the method getRest for the binary search trees
  void testGetRest(Tester t){
    //t.checkExpect(this.leafByAuthor.isLeaf(), true);
    //t.checkExpect(this.tree4.getRest(), this.tree3);
    //t.checkExpect(this.tree4a.getRest(), this.tree3);
    t.checkException(new RuntimeException("No rest of an empty tree"),
                     this.leafByAuthor, "getRest");
  }
  
  
  // test the method insert for the binary search trees
  boolean testInsert(Tester t){
    return
    t.checkExpect(this.leafByAuthor.insert(this.dvc), 
        new NodeBook(this.dvc, this.leafByAuthor, this.leafByAuthor)) &&
    t.checkExpect(this.tree3.insert(this.dvc), this.tree4);     
  }
  
  // test the method sameBook for the binary search trees
  boolean testSameBook(Tester t){
    return
    t.checkExpect(this.eh1.sameBook(this.htdp), false) &&
    t.checkExpect(this.eh1.sameBook(
        new Book("Old Man and the Sea", "EH", 1950)), true) &&
    t.checkExpect(this.eh1.sameBook(
        new Book("Old Man and the", "EH", 1950)), false) &&
    t.checkExpect(this.eh1.sameBook(
        new Book("Old Man and the Sea", "EXH", 1950)), false) &&
    t.checkExpect(this.eh1.sameBook(
        new Book("Old Man and the Sea", "EH", 1951)), false);     
  }
  
  // test the method sameTree for the binary search trees
  boolean testSameTree(Tester t){
    return
    t.checkExpect(this.leafByAuthor.sameTree(this.tree3), false) &&
    t.checkExpect(this.tree3.sameTree(this.tree3a), true) &&
    t.checkExpect(this.tree3.sameTree(this.tree3b), false) &&
    t.checkExpect(this.tree3.sameTree(this.tree4), false) &&
    t.checkExpect(this.tree3.sameTree(this.leafByAuthor), false);     
  }
  
  // test the method sameLeaf for the binary search trees
  boolean testSameLeaf(Tester t){
    return
    t.checkExpect(this.leafByAuthor.sameLeaf(new LeafBook(this.booksByAuthor)), true) &&
    t.checkExpect(this.leafByAuthor.sameLeaf(new LeafBook(this.booksByYear)), false) &&
    t.checkExpect(this.tree3.sameLeaf(new LeafBook(this.booksByAuthor)), false);     
  }
  
  // test the method sameNode for the binary search trees
  boolean testSameNode(Tester t){
    return
    t.checkExpect(this.leafByAuthor.sameNode((NodeBook)this.tree3), false) &&
    t.checkExpect(this.tree3.sameNode((NodeBook)this.tree3a), true) &&
    t.checkExpect(this.tree3.sameNode((NodeBook)this.tree3b), false) &&
    t.checkExpect(this.tree3.sameNode((NodeBook)this.tree4), false);     
  }
  
  // test bstsort(ICompareBooks order);
  void testBSTSortBooks(Tester t){
    /*
    t.checkExpect(this.mtlob.bstsort(this.booksByTitleLength), this.mtlob);
    t.checkExpect(this.blistAll.bstsort(this.booksByTitleLength), 
        this.blistByTitleLength);
    t.checkExpect(this.blistAll.bstsort(this.booksByYear), 
        this.blistByYear);
    */
  }
  
//test the method buildList for binary search trees of books
  void testBuildList(Tester t){
    /*
    t.checkExpect(this.leafByAuthor.buildList(), this.mtlob);
    t.checkExpect(this.tree4.buildList(), 
        new ConsLoB(this.dvc,
            new ConsLoB(this.sn,
                new ConsLoB(this.eh1,
                    new ConsLoB(this.htdp, this.mtlob)))));
    */
  }
  
  LeafBook leafByTitleLength = new LeafBook(this.booksByTitleLength);
  
  //test the method buildTree for the lists of books
  boolean testBuildTree(Tester t){
    return
    t.checkExpect(this.mtlob.buildTree(this.leafByTitleLength), 
        this.leafByTitleLength) &&
    t.checkExpect(this.blistAll.buildTree(this.leafByTitleLength), 
        new NodeBook(this.eh1,
                     new NodeBook(this.sn,
                                  new NodeBook(this.htdp, 
                                               this.leafByTitleLength, 
                                               this.leafByTitleLength),
                                  this.leafByTitleLength),
                     new NodeBook(this.eh2, 
                                  this.leafByTitleLength, 
                                  this.leafByTitleLength)));
  }

  
  // test the constructor for NodeBook
  boolean testConstructorNodeBook(Tester t){
	  return
	  t.checkConstructorException(
			  new RuntimeException("Invalid data for constructing a node"),
        "NodeBook", this.pc, this.tree3, this.leafByTitleLength) &&
    t.checkConstructorException(
        new RuntimeException("Invalid data for constructing a node"),
        "NodeBook", this.dvc, this.tree3, this.leafByAuthor) &&
    t.checkConstructorException(
        new RuntimeException("Invalid data for constructing a node"),
        "NodeBook", this.pc, this.leafByAuthor, this.tree3);
  }

  // run the program/tests directly
  public static void main(String[] argv){
    ExamplesBooks e = new ExamplesBooks();
    Tester.runReport(e, false, false);
    
  }
}