// a class to represent a leaf in a binary search tree
public class LeafBook extends ABSTBook{

  LeafBook(ICompareBooks comp){
		super(comp);
	}
	
	// insert the given data into this binary search tree
	public ABSTBook insert(Book data){
		return new NodeBook(data, this, this);
	}
  
  // produce the smallest item in this tree
  public Book getFirst(){
    throw new RuntimeException("No first in an empty tree");
  }
	
  // produce the biggest item in this tree
  public Book getLast(){
    throw new RuntimeException("No last in an empty tree");
  }
  
  // produce a binary search tree with the first node removed
  public ABSTBook getRest(){
    throw new RuntimeException("No rest of an empty tree");
  }
  
  // is this an empty tree? (a leaf?)
  public boolean isLeaf(){
    return true;
  }
  
  // is this tree the same in shape and data as the given tree?
  public boolean sameTree(ABSTBook that){
    return that.sameLeaf(this);
  }
  
  // does this tree have the same data as the given tree?
  public boolean sameData(ABSTBook that){
    return that.sameLeaf(this);
  }
  
  // is this leaf the same as the given leaf?
  public boolean sameLeaf(LeafBook that){
    // we assume that we always define only one comp
    return this.comp.equals(that.comp);
  }
  
  // is this leaf the same in shape and data 
  // as the tree with the given root node?
  public boolean sameNode(NodeBook that){
    return false;
  }
  
  // does this leaf have the same data 
  // as the tree with the given root node?
  public boolean sameNodeData(NodeBook that){
    return false;
  } 
  
  // convert this tree into a sorted list
  ILoB buildList(){
    return new MtLoB();
  }
  
  // does every book in this list come before the given book?
  public boolean comesBefore(Book b){
	  return true;
  }
  
  // does every book in this list come after the given book?
  public boolean comesAfter(Book b){
	  return true;
  }
}