// a class to represent a node in a binary search tree
public class NodeBook extends ABSTBook{
  Book data;
  ABSTBook left;
  ABSTBook right;

  NodeBook(Book data, ABSTBook left, ABSTBook right){
    super(left.comp);
    
    // we assume that we always define only one comp
    if (left.comp.equals(right.comp)){
        // and all nodes in the left subtree come before data
        // and all nodes in the right subtree come after data
        
		  this.data = data;
		  this.left = left;
		  this.right = right;
    } else {
      throw new RuntimeException("Invalid data for constructing a node");
    }
  }

	// insert the given data into this binary search tree
	public ABSTBook insert(Book data){
		if (this.comp.compare(data, this.data))
		  return new NodeBook(this.data, this.left.insert(data), this.right);
		else
			return new NodeBook(this.data, this.left, this.right.insert(data));
	}

  // is the tree with the root at this node 
	// the same in shape and data as the given tree?
  public boolean sameTree(ABSTBook that){
    return that.sameNode(this);
  }
  
  // is the tree with the root at this node
  // the same as the given leaf?
  public boolean sameLeaf(LeafBook that){
    return false;
  }
  
  // is the tree with the root at this node
  // the same in shape and data 
  // as the tree with the given root node?
  public boolean sameNode(NodeBook that){
    return this.data.sameBook(that.data)
        && this.left.sameTree(that.left)
        && this.right.sameTree(that.right);
  }
}